> This page is for Developer Documentation.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.benchling.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.benchling.com/_mcp/server.

# Bulk upsert custom entities

POST https://{tenant_name}.benchling.com/api/v2-beta/custom-entities:bulk-upsert
Content-Type: application/json

All entities and their schemas must be within the same registry.

This operation performs the following actions:

1. Any existing objects are looked up in Benchling by the provided entity registry ID.
2. Then, all objects are either created or updated accordingly, temporarily skipping any schema field links between objects.
3. Schema field links can be populated using entity registry IDs or API IDs. In the `value` field of the [Field](#/components/schemas/FieldWithResolution) resource, the object `{"entityRegistryId": ENTITY_REGISTRY_ID}` may be provided instead of the API ID if desired (see example value). You may link to objects being created in the same operation.
4. Entities are registered, using the provided name and entity registry ID.

If any action fails, the whole operation is canceled and no objects are created or updated.

Limit of 2500 custom entities per request.

Reference: https://docs.benchling.com/docs/api/v2-beta/benchling-api-beta/custom-entities/bulk-upsert-custom-entities

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Body (application/json)

This endpoint expects a CustomEntitiesBulkUpsertRequest.

- `customEntities` (list of CustomEntityBulkUpsertRequest, required)

## Response

### 202

This endpoint launches a [long-running task](#/Tasks/getTask) and returns the Task ID of the launched task. When successful, the task returns the resources of the objects that were upserted.

- `taskId` (string, optional)

## Errors

### 400 Bad Request Error

Bad Request

- `error` (BadRequestErrorError, optional)

## Types

### CustomEntityBulkUpsertRequest

- `name` (string, required)
- `registryId` (string, required)
- `schemaId` (string, required)
- `entityRegistryId` (string, required) — Registry ID of the entity in Benchling.
- `archiveRecord` (ArchiveRecordSet, optional) — Currently, we only support setting a null value for archiveRecord, which unarchives the item
- `fields` (map from string to FieldWithResolution, optional) — Schema fields to set on the custom entity. Must correspond with the schema's field definitions. Every field should have its name as a key, mapping to an object with information about the value of the field.
- `aliases` (list of string, optional) — Aliases to add to the custom entity
- `authorIds` (list of string, optional) — IDs of users to set as the custom entity's authors.
- `customFields` (map from string to CustomField, optional) — Custom fields to add to the custom entity. Every field should have its name as a key, mapping to an object with information about the value of the field.
- `folderId` (string, optional) — ID of the folder that the entity is moved into

### BadRequestErrorError

- `message` (string, optional)
- `type` (enum, optional)
  - Allowed values: `invalid_request_error`
- `userMessage` (string, optional)

### ArchiveRecordSet

Currently, we only support setting a null value for archiveRecord, which unarchives the item

### FieldWithResolution

- `value` (FieldWithResolutionValue, required, nullable) — For single link fields, use the id of the item you want to link (eg. "seq_jdf8BV24"). For multi-link fields, use an array of ids of the items you want to link (eg. ["seq_jdf8BV24"])
- `displayValue` (string, optional, nullable)
- `isMulti` (boolean, optional)
- `textValue` (string, optional, nullable)
- `type` (enum, optional)
  - Allowed values: `dna_sequence_link`, `aa_sequence_link`, `custom_entity_link`, `entity_link`, `mixture_link`, `molecule_link`, `dropdown`, `part_link`, `translation_link`, `aa_part_link`, `base_molecule_link`, `blob_link`, `text`, `long_text`, `batch_link`, `storage_link`, `entry_link`, `assay_request_link`, `assay_result_link`, `assay_run_link`, `boolean`, `float`, `integer`, `datetime`, `date`, `json`

### CustomField

- `value` (string, optional)

### FieldWithResolutionValue

For single link fields, use the id of the item you want to link (eg. "seq_jdf8BV24"). For multi-link fields, use an array of ids of the items you want to link (eg. ["seq_jdf8BV24"])

## Examples

**Request**

```json
{
  "customEntities": [
    {
      "name": "string",
      "registryId": "string",
      "schemaId": "string",
      "entityRegistryId": "string"
    }
  ]
}
```

**Response**

```json
{
  "taskId": "string"
}
```

**SDK Code**

```python
import requests

url = "https://{tenant_name}.benchling.com/api/v2-beta/custom-entities:bulk-upsert"

payload = { "customEntities": [
        {
            "name": "string",
            "registryId": "string",
            "schemaId": "string",
            "entityRegistryId": "string"
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://{tenant_name}.benchling.com/api/v2-beta/custom-entities:bulk-upsert';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"customEntities":[{"name":"string","registryId":"string","schemaId":"string","entityRegistryId":"string"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```